#import "ApplicationController.h"

@implementation ApplicationController

- (id)init
{
    if (self = [super init])
    {
		items = [[NSMutableArray alloc] init];
	}
	
	return self;
}

- (void)applicationWillTerminate:(NSNotification *)aNotification
{
	NSMutableDictionary *itemStringAndNotes = [[NSMutableDictionary alloc] init];
	
	int i;
	for (i = 0; i < 10; i++) {
		[itemStringAndNotes setObject:[[items objectAtIndex:i] notes] forKey:[[NSNumber numberWithInt:i] stringValue]];
	}
	
	[itemStringAndNotes writeToFile:[@"~/Library/Application Support/BindThisTextView/data folder/data.xml" stringByExpandingTildeInPath] atomically:YES];
	
	[itemStringAndNotes release];
}

- (void) dealloc
{
    [items release];
    
    [super dealloc];
}

- (NSString *)name
{
    return name;
}

- (NSString *)description
{
    return description;
}

- (NSArray *)items
{
    return (NSArray*)items;
}

- (void) setItems: (NSArray *)newItems
{
    if (items != newItems)
    {
        [items autorelease];
        items = [[NSMutableArray alloc] initWithArray: newItems];
    }
}

- (void) awakeFromNib
{
	[items removeAllObjects];
		
	NSDictionary *itemStringAndNotes = [[NSDictionary alloc] initWithContentsOfFile:[[[@"~/Library/Application Support/BindThisTextView/"
					stringByAppendingPathComponent:@"data folder"] stringByAppendingPathComponent:@"data.xml"]
																			  stringByExpandingTildeInPath]];
	NSAttributedString *itemNotesString;
	NSString *itemString;

	int i;
	for (i = 0; i < 10; i++) {	
		if (itemStringAndNotes) {
			itemNotesString = [[NSAttributedString alloc] initWithString:(NSString *)[itemStringAndNotes objectForKey:[[NSNumber numberWithInt:i] stringValue]]];
			itemString = [[NSNumber numberWithInt:i] stringValue];
		}
		else {						  
			itemNotesString = [[NSAttributedString alloc] initWithString:@""];
			itemString = [[NSNumber numberWithInt:i] stringValue];
		}
		
		[self willChangeValueForKey:@"items"]; 
		[items addObject:[[Item alloc] initWithItemString:itemString andNotes:itemNotesString]];
		[self didChangeValueForKey:@"items"]; 
	}
}

@end
